/*
This program is made to compute the c(a) test simulation resutls again.

While replying to the referee, we've found that the c(a) test in the revision is not correct.

Jin Seo Cho

Obtained critical value at 
                          10%          3.324525 
                         7.5%          3.8111
                         5.0%          4.5081
                         2.5%          5.7209

(2*10^7 times iterations)

Look at the program code: calp_modi_null.prg
*/

new;
library pgraph;

nnn = 500;           /* # of obd */
kkk = 3000;            /* # of interations */

p1  = 0.9;                    /*********** Panel Indicator *********************/
q1  = 1-p1;
pp  = (1-q1)/(2-p1-q1);
tm1 = 1;
tm2 = 2;


/********************************************************************************/

sdd = 0.2;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
ca5p0 = (qqq[.,3] .> 4.508150);

print "J-B test";
print "5.0%" meanc(jb5p0);
print "Calp test";
print "5.0%" meanc(ca5p0);

col1_jb = qqq[.,1:2];
col1_ca = qqq[.,1]~qqq[.,3];


/********************************************************************************/

sdd = 0.4;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
ca5p0 = (qqq[.,3] .> 4.508150);

print "J-B test";
print "5.0%" meanc(jb5p0);
print "Calp test";
print "5.0%" meanc(ca5p0);

col2_jb = qqq[.,2];
col2_ca = qqq[.,3];


/********************************************************************************/

sdd = 0.6;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
ca5p0 = (qqq[.,3] .> 4.508150);

print "J-B test";
print "5.0%" meanc(jb5p0);
print "Calp test";
print "5.0%" meanc(ca5p0);

col3_jb = qqq[.,2];
col3_ca = qqq[.,3];


/********************************************************************************/

sdd = 0.8;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
ca5p0 = (qqq[.,3] .> 4.508150);

print "J-B test";
print "5.0%" meanc(jb5p0);
print "Calp test";
print "5.0%" meanc(ca5p0);

col4_jb = qqq[.,2];
col4_ca = qqq[.,3];


/********************************************************************************/

sdd = 1;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
ca5p0 = (qqq[.,3] .> 4.508150);

print "J-B test";
print "5.0%" meanc(jb5p0);
print "Calp test";
print "5.0%" meanc(ca5p0);

col5_jb = qqq[.,2];
col5_ca = qqq[.,3];

col1_jb[.,2] = sortc(col1_jb[.,2],1);
col2_jb[.,1] = sortc(col2_jb[.,1],1);
col3_jb[.,1] = sortc(col3_jb[.,1],1);
col4_jb[.,1] = sortc(col4_jb[.,1],1);
col5_jb[.,1] = sortc(col5_jb[.,1],1);

col1_ca[.,2] = sortc(col1_ca[.,2],1);
col2_ca[.,1] = sortc(col2_ca[.,1],1);
col3_ca[.,1] = sortc(col3_ca[.,1],1);
col4_ca[.,1] = sortc(col4_ca[.,1],1);
col5_ca[.,1] = sortc(col5_ca[.,1],1);

output file = table4_jb_5th_pn.txt reset;                          /*************** File Name *******************/
screen off;
print col1_jb~col2_jb~col3_jb~col4_jb~col5_jb;
screen on;
output off;

output file = table4_ca_5th_pn.txt reset;                          /*************** File Name *******************/
screen off;
print col1_ca~col2_ca~col3_ca~col4_ca~col5_ca;
screen on;
output off;
